com.io7m.jtensors.storage.bytebuffered

## Class PVectorByteBufferedIntegral4s64<T>

- java.lang.Object
- - com.io7m.jtensors.storage.bytebuffered.PVectorByteBufferedIntegral4s64<T>

- Type Parameters:
    `T` - A phantom type parameter
  All Implemented Interfaces:
    PVectorReadable2LType<T>, PVectorReadable3LType<T>, PVectorReadable4LType<T>, VectorReadable2LType, VectorReadable3LType, VectorReadable4LType, PVectorStorageIntegral2Type<T>, PVectorStorageIntegral3Type<T>, PVectorStorageIntegral4Type<T>, VectorStorageIntegral2Type, VectorStorageIntegral3Type, VectorStorageIntegral4Type, VectorStorageType, PVectorByteBufferedIntegral4Type<T>, TensorByteBufferedType, VectorByteBufferedType

      public final class PVectorByteBufferedIntegral4s64<T>
      extends Object
      implements PVectorByteBufferedIntegral4Type<T>

  A storage vector.

  Storage component type: `long`

  Storage component count: `4`

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `ByteBuffer` | `byteBuffer()`
    `long` | `byteOffset()`
    `protected int` | `byteOffsetForIndex(int component_index)`
    `protected int` | `componentBytes()`
    `protected int` | `componentCount()`
    `static <T> PVectorByteBufferedIntegral4s64<T>` | `createWithBase(ByteBuffer b, com.io7m.mutable.numbers.core.MutableLongType base, int offset)` Return a new vector that is backed by the given byte buffer `b`
    `int` | `offset()`
    `void` | `setW(long w)` Set the `w` component.
    `void` | `setX(long x)` Set the `x` component.
    `void` | `setY(long y)` Set the `Y` component.
    `void` | `setZ(long z)` Set the `z` component.
    `int` | `sizeBytes()`
    `long` | `w()`
    `long` | `x()`
    `long` | `y()`
    `long` | `z()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.io7m.jtensors.storage.api.parameterized.vectors.PVectorStorageIntegral4Type

      `setPVector4I, setPVector4L`

    - ### Methods inherited from interface com.io7m.jtensors.storage.api.parameterized.vectors.PVectorStorageIntegral3Type

      `setPVector3I, setPVector3L`

    - ### Methods inherited from interface com.io7m.jtensors.storage.api.parameterized.vectors.PVectorStorageIntegral2Type

      `setPVector2I, setPVector2L`

    - ### Methods inherited from interface com.io7m.jtensors.storage.api.unparameterized.vectors.VectorStorageIntegral4Type

      `setVector4I, setVector4L, setXYZW`

    - ### Methods inherited from interface com.io7m.jtensors.storage.api.unparameterized.vectors.VectorStorageIntegral3Type

      `setVector3I, setVector3L, setXYZ`

    - ### Methods inherited from interface com.io7m.jtensors.storage.api.unparameterized.vectors.VectorStorageIntegral2Type

      `setVector2I, setVector2L, setXY`

    - ### Methods inherited from interface com.io7m.jtensors.storage.bytebuffered.TensorByteBufferedType

      `byteBuffer, byteOffset, offset, sizeBytes`

- - ### Method Detail

    - #### createWithBase

          public static <T> PVectorByteBufferedIntegral4s64<T> createWithBase(ByteBuffer b,
                                                                              com.io7m.mutable.numbers.core.MutableLongType base,
                                                                              int offset)

      Return a new vector that is backed by the given byte buffer `b`

      The data for the instance will be taken from the data at the current value of `base.get() + offset`, each time a field is requested or set.

      No initialization of the data is performed.

      Type Parameters:
        `T` - A phantom type parameter
      Parameters:
        `b` - The byte buffer
        `base` - The base address
        `offset` - A constant offset
      Returns:
        A new buffered vector

    - #### componentCount

          protected int componentCount()

    - #### x

          public long x()

      Specified by:
        `x` in interface `VectorReadable2LType`
      Returns:
        The `x` component

    - #### y

          public long y()

      Specified by:
        `y` in interface `VectorReadable2LType`
      Returns:
        The `y` component

    - #### z

          public long z()

      Specified by:
        `z` in interface `VectorReadable3LType`
      Returns:
        The `z` component

    - #### w

          public long w()

      Specified by:
        `w` in interface `VectorReadable4LType`
      Returns:
        The `w` component

    - #### setX

          public void setX(long x)

      Description copied from interface: `VectorStorageIntegral2Type`
      Set the `x` component.
      Specified by:
        `setX` in interface `VectorStorageIntegral2Type`
      Parameters:
        `x` - The X component

    - #### setY

          public void setY(long y)

      Description copied from interface: `VectorStorageIntegral2Type`
      Set the `Y` component.
      Specified by:
        `setY` in interface `VectorStorageIntegral2Type`
      Parameters:
        `y` - The Y component

    - #### setZ

          public void setZ(long z)

      Description copied from interface: `VectorStorageIntegral3Type`
      Set the `z` component.
      Specified by:
        `setZ` in interface `VectorStorageIntegral3Type`
      Parameters:
        `z` - The Z component

    - #### setW

          public void setW(long w)

      Description copied from interface: `VectorStorageIntegral4Type`
      Set the `w` component.
      Specified by:
        `setW` in interface `VectorStorageIntegral4Type`
      Parameters:
        `w` - The W component

    - #### componentBytes

          protected final int componentBytes()

    - #### byteBuffer

          public final ByteBuffer byteBuffer()

      Specified by:
        `byteBuffer` in interface `TensorByteBufferedType`
      Returns:
        The byte buffer that backs the tensor

    - #### byteOffset

          public final long byteOffset()

      Specified by:
        `byteOffset` in interface `TensorByteBufferedType`
      Returns:
        The byte offset of the current tensor

    - #### offset

          public final int offset()

      Specified by:
        `offset` in interface `TensorByteBufferedType`
      Returns:
        A constant offset added to `TensorByteBufferedType.byteOffset()`.

    - #### sizeBytes

          public final int sizeBytes()

      Specified by:
        `sizeBytes` in interface `TensorByteBufferedType`
      Returns:
        The size of a single tensor in bytes

    - #### byteOffsetForIndex

          protected final int byteOffsetForIndex(int component_index)

Copyright © 2017 <code@io7m.com> http://io7m.com